package de.intevation.gnv.raster;

public class IsoAttributeGenerator
implements   IsoPolygonSeriesProducer.AttributeGenerator
{
    protected Palette palette;

    public IsoAttributeGenerator() {
    }

    public IsoAttributeGenerator(Palette palette) {
        this.palette = palette;
    }

    public Object generateAttribute(int neighbor1, int neighbor2) {
        Palette.Entry e1 = palette.getEntryByIndex(neighbor1);
        Palette.Entry e2 = palette.getEntryByIndex(neighbor2);

        if (e1 == null || e2 == null) {
            return null;
        }

        double e1t = e1.getFrom();
        double e2f = e2.getTo();

        return Double.valueOf(e2f >= e1t
            ? 0.5d*(e1t+e2f)
            : 0.5d*(e2.getTo()+e1.getFrom()));
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
